#include <quark.hpp>
#include <glm/vec3.hpp>
#include "imgui.h"

class ExampleLayer :
	public qk::Layer
{
public:
	ExampleLayer() :
		Layer("Example")
	{
		glm::vec3 test = { 0.0f, 1.0f, 0.75f };
	}

	void OnUpdate() override {
		// QK_TRACE("ExampleLayer::Update");
		
		if (qk::Input::IsKeyDown(QK_KEY_TAB)) {
			QK_TRACE("Tab pressed");
		}
	}

	void OnImGuiRender() override {
		static bool open = true;

		if (ImGui::Begin("Example window", &open)) {
			ImGui::Text("Example text");
			ImGui::End();
		}
	}

	void OnEvent(qk::Event& event) override {
		// QK_TRACE(event);
	}
};

class Sandbox :
	public qk::Application
{
public:
	Sandbox() {
		PushLayer(new ExampleLayer);
	}
};

qk::Application* qk::CreateApplication() {
	return new Sandbox;
}
